<?php
/*
* Simple yet effective counting script
* by Martijn de Meulder. - http://www.martijndemeulder.com (contains referrer log parts from www.spyka.net/scripts)
* version: 1.2.0
* copyright (c) 2008-2010 Martijn de Meulder
* license http://opensource.org/licenses/gpl-license.php GNU Public License
*/

////////// Administrative section //////////////

// Set day of the week
$jd=cal_to_jd(CAL_GREGORIAN,date("m"),date("d"),date("Y"));
$todayis=(jddayofweek($jd,1));

// Files where your data are stored - never ever change the name of the day, because it comes from the jddayofweek() function above
if ($todayis == "Monday") {
$file = 'count/mondaysreferrers.db';
} elseif ($todayis == "Tuesday") {
$file = 'count/tuesdaysreferrers.db';
} elseif ($todayis == "Wednesday") {
$file = 'count/wednesdaysreferrers.db';
} elseif ($todayis == "Thursday") {
$file = 'count/thursdaysreferrers.db';
} elseif ($todayis == "Friday") {
$file = 'count/fridaysreferrers.db';
} elseif ($todayis == "Saturday") {
$file = 'count/saturdaysreferrers.db';
} elseif ($todayis == "Sunday") {
$file = 'count/sundaysreferrers.db';
}
$file2 = 'count/hits.db';
$file3 = 'count/ip.db';
$file4 = 'count/uniques.db';
$file5 = 'count/keywords.db';

include("english.php"); /* translations and color codes to be shared between counter.php and index.php */

// if set to 1 IPs will be logged and associated with the URL they were referred by
$log_ip = 1;

////////// End administrative section //////////////

////////// Start collecting search strings //////////////

$hostname = gethostbyaddr($_SERVER['REMOTE_ADDR']);

$query_part=strstr($_SERVER['HTTP_REFERER'], "q=");

$param_array=explode('&', $query_part);

foreach ($param_array as $param)
{
if ($param{0} == 'q') // if first char is q, it's your google query.
{
$word_string = substr($param, 2); // strip 'q='
}
}
$keywords = str_replace('"', '', urldecode($word_string));

// If no keywords are present, no data is printed
if ($keywords == "") {
$printkeywords = "";
} else {
$printkeywords = "<br>$keywordstxt:<font color=$highlightedcolor><b> $keywords</font>";
}

////////// End collecting search strings //////////////

// collect IP address of your visitor
$ip1 = ($log_ip == 1) ? $_SERVER['REMOTE_ADDR'] : false;

// whatis the name of the pages your visitor sees?
$url25 = $_SERVER['REQUEST_URI'];


/*
////////////// Filter your own IPs from the log so they wont show up in the stats //////////////
/// Disabled by default

if ($ip1 == "127.0.0.1") {
exit();
} elseif ($ip1 == "192.168.1.100")  {
exit();
} elseif ($ip1 == "192.168.1.110")  {
exit();
} elseif ($ip1 == "192.168.1.120")  {
exit();
} elseif ($ip1 == "192.168.1.130")  {
exit();
}

////////////// End filter own IPs //////////////

*/

////////// Collect ISP name //////////////

function getisp($ip='') {
   if ($ip=='') $ip = $_SERVER['REMOTE_ADDR'];
   $longisp = @gethostbyaddr($ip);
   $isp = explode('.', $longisp);
   $isp = array_reverse($isp);
   $tmp = $isp[1];
   if (preg_match("/\<(org?|com?|net)\>/i", $tmp)) {
       $myisp = $isp[2].'.'.$isp[1].'.'.$isp[0];
   } else {
       $myisp = $isp[1].'.'.$isp[0];
   }
   if (preg_match("/[0-9]{1,3}\.[0-9]{1,3}/", $myisp))
      return '(onbekend)';
   return $myisp;
}

$isp_name = getisp();

////////// End collecting ISP name //////////////

////////// Collect referrer //////////////

$tracking = $_SERVER['HTTP_REFERER'];

// If no referrer is present, no data is printed
if(isset($tracking)) {
$printrefer = "<br>$referer:<font color=$whitecolor><b> $tracking</font></b>";
} else {
$printrefer = "";
}

// Compile data
$time = date('l jS \of F Y G:i:s');
$user_text  = ($log_ip == 1) ? "{$ontxt} {$time}" : "{$ontxt} {$time} ";
$refer_text = "{$user_text} {$visitortxt} <i>{$ip1} {$isp_name}</i> {$onpagetxt} <font color={$highlightedcolor}>{$url25}</font>{$printkeywords}</b>{$printrefer}<p>";

// Write the file, plain appending to teh file
// $fp = fopen($file, 'a');
// fwrite($fp, "{$refer_text}\n");
// fclose($fp);

// but.. we like it better to have the lines added at the top, so we copy the file to an array, then write the fresh data, then append the array to that.
$array = file("$file");
$fopen = fopen("$file", "w+");
fwrite( $fopen, "{$refer_text}\n");
foreach ($array as $line2) { fwrite( $fopen, "$line2"); }
fclose($fopen);

////////// End collecting referrer //////////////

////////// Write keywords ///////////////


// If keywords are irrelevant, no data is printed
if ($keywords == "") {
$keywordstring = "";
} else {
$keywordstring = "{$keywords}&nbsp<font color={$textcolor}>|</font>&nbsp";
}

// Write the file
$fp = fopen($file5, 'a');
fwrite($fp, "{$keywordstring}\n");
fclose($fp);

////////// End writing keywords ///////////////

////////// Counting your hits //////////////

// Reading out quantity
$fh = fopen($file2, 'r');
$readdata = fread($fh, filesize($file2));
fclose($fh);

// Counting
if ($readdata == 0) {
$writedata = 1;
} else {
$writedata = $readdata + 1;
}

// Writing new Quantity
$fh = fopen($file2, 'w') or die("can't open file");
$stringData = "$writedata\n";
fwrite($fh, $stringData);
fclose($fh);

////////////// End counting hits //////////////


////////// Count your unique visitors ////////

$file_ip = fopen($file3, 'rb');
while (!feof($file_ip)) $line[]=fgets($file_ip,1024);
for ($i=0; $i<(count($line)); $i++) {
   list($ip_x) = split("\n",$line[$i]);
   if ($ip1 == $ip_x) {$found = 1;}
}
fclose($file_ip);

if (!($found==1)) {
   $file_ip2 = fopen($file3, 'ab');
   $line = "$ip1\n";
   fwrite($file_ip2, $line, strlen($line));
   $file_count = fopen($file4, 'rb');
   $data = '';
   while (!feof($file_count)) $data .= fread($file_count, 4096);
   fclose($file_count);
   list($today, $yesterday, $total, $date, $days) = split("%", $data);
   if ($date == date("Y m d")) $today++;
      else {
         $yesterday = $today;
         $today = 1;
         $days++;
         $date = date("Y m d");
      }
   $total++;
   $line = "$today%$yesterday%$total%$date%$days";

   $file_count2 = fopen($file4, 'wb');
   fwrite($file_count2, $line, strlen($line));
   fclose($file_count2);
   fclose($file_ip2);
}

////////// End counting uniques ////////

/* EMAIL AND TWITTER DISABLED BY DEFAULT, ONLY ENABLE EMAIL ON LOW VOLUME SITE

///////// Extra routine: receive email when someone visits your site, only for _extremely_ low volume-sites of course /////////

$to = $myemail;
//define the subject of the email
$subject = $basesubject . $ip1 . $separate . $isp_name;
//define the message to be sent. Each line should be separated with \n
$message = $emailcontent;
//define the headers we want passed. Note that they are separated with \r\n
$headers = $emailheaders;
//send the email
$mail_sent = @mail( $to, $subject, $message, $headers );
//if the message is sent successfully you might want to print "Mail sent". Otherwise print "Mail failed", in this counter it's probabaly unnnescesary, but the code is here for, whenever.

// echo $mail_sent ? "Mail sent" : "Mail failed";

///////// End sending email /////////


// TWITTER

///////// Extra routine: post your hits to Twitter, you MUST make a separate account to post the counter statistics to, which you in turn can follow from your main Twitter account /////////

$tweet = $basesubject . $ip1 . $separate . $isp_name; // same as subject above, but here if you want to disable email but still want to tweet
$twitter_data = $readdata . "hits " . $tweet; // the string readdata is taken from the hit counter above

// now the $twitter_data is ready to get posted to Twitter, unfortunately since september 1st 2010 it is no longer possible to use the simple authentication model involving cURL that this counter used before. You have to use Oauth, this involves some significant PHP-hackery to custom build your own interface to your counter account.

Please follow the excellent tutorial to have your own $twitter_data posted:
http://www.snipe.net/2009/07/writing-your-first-twitter-application-with-oauth/

Good luck and have fun!

/// end TWITTER

// end script, now view your aggregated data in index.php

?>
